import * as React from 'react';
import { IRecoil } from '../..';
export interface IButtonProps extends IRecoil {
    style?: Object;
    onClick?: (event: React.MouseEvent<any>) => void;
    pointer?: 'left' | 'right' | boolean;
    iconPointer?: 'left' | 'right' | 'up' | 'down';
    iconLocation?: 'left' | 'right';
    checkedTheme?: 'primary' | 'success' | 'error' | 'default';
    icon?: string;
    href?: string;
    target?: string;
    block?: boolean;
    strech?: boolean;
    right?: boolean;
    left?: boolean;
    submit?: boolean;
    advanced?: boolean;
    ghost?: boolean;
    required?: boolean;
    id?: string;
    shortcut?: string;
    materialIcon?: boolean;
    onMouseEnter?: (event: React.MouseEvent<any>) => void;
    shortCutInitKey?: string[];
    fileUpload?: boolean;
    onChange?(e: any): void;
}
export interface IButtonState {
    checked?: boolean;
    showShortcut?: any;
}
export default class AdvancedButton extends React.Component<IButtonProps, IButtonState> {
    refs: {
        [key: string]: Element;
        button: HTMLButtonElement;
    };
    static defaultProps: {
        disabled: boolean;
        block: boolean;
        advanced: boolean;
        iconLocation: string;
        scrollDuration: number;
        scrollOffset: number;
    };
    constructor(props: IButtonProps);
    onClick(event: React.MouseEvent<MouseEvent>): void;
    onMouseEnter(event: React.MouseEvent<MouseEvent>): void;
    onChangeFileUpload(e: any): void;
    render(): JSX.Element;
}
