"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classNames = require("classnames");
var Selectable_1 = require("../Selectable/Selectable");
var AdvancedButton = (function (_super) {
    __extends(AdvancedButton, _super);
    function AdvancedButton(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            checked: false,
            showShortcut: false
        };
        return _this;
    }
    AdvancedButton.prototype.onClick = function (event) {
        this.props.onClick ? this.props.onClick(event) : null;
    };
    AdvancedButton.prototype.onMouseEnter = function (event) {
        this.props.onMouseEnter ? this.props.onMouseEnter(event) : null;
    };
    AdvancedButton.prototype.onChangeFileUpload = function (e) {
        this.props.onChange ? this.props.onChange(e.target.files[0]) : null;
    };
    AdvancedButton.prototype.render = function () {
        var _this = this;
        var self = this;
        var props = self.props;
        var buttonType;
        var buttonClass = classNames('r-Button', { simple: props.simple }, { 'e-required': props.required }, { outline: props.outline }, { block: props.block }, { column: props.strech }, { icon: !props.children }, { 'button-pointer-right': props.pointer === 'right' }, { 'button-pointer-left': props.pointer === 'left' }, { 'icon-right': props.iconLocation === 'right' }, { 'icon-left': props.iconLocation === 'left' }, { 'pull-right': props.right }, { 'pull-left': props.left }, props.size, props.theme, props.className, { checked: props.checked }, { fill: props.fill });
        if (props.submit) {
            buttonType = 'submit';
        }
        else {
            buttonType = 'button';
        }
        var showTooltip = function () {
            if (_this.state.showShortcut) {
                return React.createElement("div", { className: "animated text-center fadeIn w100" }, _this.props.shortcut);
            }
        };
        var selectablePartial = React.createElement(Selectable_1.default, { type: props.checkedTheme, checked: props.checked ? true : false });
        var iconPartial = props.icon && !props.loading ? (props.materialIcon ? (React.createElement("i", { className: 'material-icons' }, props.icon)) : (React.createElement("i", { className: 'fa fa-' + props.icon }))) : null;
        var loadingPartial = props.loading ? (React.createElement("i", { className: 'fa fa-circle-o-notch fa-spin' + (props.children ? ' mr10' : '') })) : null;
        var animatedIcon = props.iconPointer && !props.loading ? React.createElement("i", { className: 'icon-pointer fa fa-caret-' + props.iconPointer }) : null;
        var iconWrapperRight = props.icon && props.iconLocation === 'right' && !this.state.showShortcut ? (React.createElement("div", { className: 'icon-pointer-' + props.iconPointer + ' ml10 icon-wrapper' },
            iconPartial,
            props.iconPointer ? animatedIcon : null)) : null;
        var iconWrapperLeft = props.icon && props.iconLocation === 'left' && !this.state.showShortcut ? (React.createElement("div", { className: 'icon-pointer-' + props.iconPointer + ' icon-wrapper ' + (props.children ? 'mr10' : '') },
            iconPartial,
            props.iconPointer ? animatedIcon : null)) : null;
        var LinkButton = function (_a) {
            var innerRef = _a.innerRef;
            return (React.createElement("a", { href: props.href, id: props.id, target: props.target, ref: innerRef, tabIndex: props.tabIndex, onClick: _this.onClick.bind(_this), className: buttonClass, style: props.style },
                iconWrapperLeft,
                loadingPartial,
                !_this.state.showShortcut ? props.children : showTooltip(),
                selectablePartial,
                iconWrapperRight));
        };
        var SimpleButton = function (_a) {
            var innerRef = _a.innerRef;
            return (React.createElement("button", { id: props.id, ref: innerRef, tabIndex: props.tabIndex, onClick: _this.onClick.bind(_this), type: buttonType, disabled: props.disabled || props.loading === true, className: buttonClass, style: props.style },
                iconWrapperLeft,
                loadingPartial,
                !_this.state.showShortcut ? props.children : showTooltip(),
                iconWrapperRight));
        };
        var DefaultButton = function (_a) {
            var innerRef = _a.innerRef;
            return (React.createElement("button", { id: props.id, ref: innerRef, onMouseEnter: _this.props.onMouseEnter ? _this.onMouseEnter.bind(_this) : null, tabIndex: props.tabIndex, onClick: _this.onClick.bind(_this), type: buttonType, disabled: props.disabled || props.loading === true, className: buttonClass, style: props.style },
                iconWrapperLeft,
                loadingPartial,
                !_this.state.showShortcut ? props.children : showTooltip(),
                selectablePartial,
                iconWrapperRight));
        };
        var FileButton = function (_a) {
            var innerRef = _a.innerRef;
            return (React.createElement("div", { id: props.id, ref: innerRef, onMouseEnter: _this.props.onMouseEnter ? _this.onMouseEnter.bind(_this) : null, className: buttonClass, style: props.style },
                iconWrapperLeft,
                loadingPartial,
                !_this.state.showShortcut ? props.children : showTooltip(),
                selectablePartial,
                iconWrapperRight,
                React.createElement("input", { onChange: _this.onChangeFileUpload.bind(_this), className: "r-Button-File", type: "file", accept: "image/*" })));
        };
        var Link = React.forwardRef(function (props, ref) { return React.createElement(LinkButton, { innerRef: ref }); });
        var Simple = React.forwardRef(function (props, ref) { return React.createElement(SimpleButton, { innerRef: ref }); });
        var Default = React.forwardRef(function (props, ref) { return React.createElement(DefaultButton, { innerRef: ref }); });
        var FileUpload = React.forwardRef(function (props, ref) { return React.createElement(FileButton, { innerRef: ref }); });
        if (props.href) {
            return React.createElement(Link, null);
        }
        else if (props.fileUpload) {
            return React.createElement(FileUpload, null);
        }
        else {
            return props.advanced ? React.createElement(Default, null) : React.createElement(Simple, null);
        }
    };
    AdvancedButton.defaultProps = {
        disabled: false,
        block: false,
        advanced: false,
        iconLocation: 'left',
        scrollDuration: 300,
        scrollOffset: 0
    };
    return AdvancedButton;
}(React.Component));
exports.default = AdvancedButton;
//# sourceMappingURL=AdvancedButton.js.map