"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classNames = require("classnames");
var Selectable_1 = require("../Selectable/Selectable");
var Button = (function (_super) {
    __extends(Button, _super);
    function Button() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Button.prototype.onClick = function (event) {
        this.props.onClick ? this.props.onClick(event) : null;
    };
    Button.prototype.render = function () {
        var _this = this;
        var self = this;
        var props = self.props;
        var buttonType;
        var buttonClass = classNames('r-Button', { simple: props.simple }, { 'e-required': props.required }, { outline: props.outline }, { block: props.block }, { column: props.strech }, { icon: !props.children }, { 'button-pointer-right': props.pointer === 'right' }, { 'button-pointer-left': props.pointer === 'left' }, { 'icon-right': props.iconLocation === 'right' }, { 'icon-left': props.iconLocation === 'left' }, { 'pull-right': props.right }, { 'pull-left': props.left }, props.size, props.theme, props.className, { checked: props.checked }, { fill: props.fill });
        if (props.submit) {
            buttonType = 'submit';
        }
        else {
            buttonType = 'button';
        }
        var iconPartial = props.icon && !props.loading ? (props.materialIcon ? (React.createElement("i", { className: 'material-icons' }, props.icon)) : (React.createElement("i", { className: 'fa fa-' + props.icon }))) : null;
        var loadingPartial = props.loading ? (React.createElement("i", { className: 'fa fa-circle-o-notch fa-spin' + (props.children ? ' mr10' : '') })) : null;
        var animatedIcon = props.iconPointer && !props.loading ? React.createElement("i", { className: 'icon-pointer fa fa-caret-' + props.iconPointer }) : null;
        var iconWrapperRight = props.icon && props.iconLocation === 'right' ? (React.createElement("div", { className: 'icon-pointer-' + props.iconPointer + ' ml10 icon-wrapper' },
            iconPartial,
            props.iconPointer ? animatedIcon : null)) : null;
        var iconWrapperLeft = props.icon && props.iconLocation === 'left' ? (React.createElement("div", { className: 'icon-pointer-' + props.iconPointer + ' icon-wrapper ' + (props.children ? 'mr10' : '') },
            iconPartial,
            props.iconPointer ? animatedIcon : null)) : null;
        var SimpleButton = function (_a) {
            var innerRef = _a.innerRef;
            return (React.createElement("button", { id: props.id, ref: innerRef, tabIndex: props.tabIndex, onClick: _this.onClick.bind(_this), type: buttonType, disabled: props.disabled || props.loading === true, className: buttonClass, style: props.style },
                iconWrapperLeft,
                loadingPartial,
                props.children,
                iconWrapperRight,
                React.createElement(Selectable_1.default, { type: props.checkedTheme, checked: props.checked ? true : false })));
        };
        var Button = React.forwardRef(function (props, ref) { return React.createElement(SimpleButton, { innerRef: ref }); });
        return React.createElement(Button, null);
    };
    Button.defaultProps = {
        disabled: false,
        block: false,
        advanced: false,
        iconLocation: 'left'
    };
    return Button;
}(React.Component));
exports.default = Button;
//# sourceMappingURL=Button.js.map