"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Button_1 = require("../Button/Button");
var Toolbar_1 = require("../Toolbar/Toolbar");
var classNames = require("classnames");
var Checkbox = (function (_super) {
    __extends(Checkbox, _super);
    function Checkbox() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.toggleChecked = function () {
            _this.props.onChange ? _this.props.onChange(_this.props.checked) : null;
        };
        return _this;
    }
    Checkbox.prototype.render = function () {
        var self = this;
        var props = self.props;
        var checked = props.checked, disabled = props.disabled, icon = props.icon, loading = props.loading, theme = props.theme, size = props.size;
        var checkboxClass = classNames('r-Checkbox', { disabled: props.disabled }, { 'e-checked': this.props.checked });
        var checkboxProps = {
            disabled: disabled,
            loading: loading,
            size: size,
            icon: icon,
            onClick: this.toggleChecked,
            theme: theme ? theme : checked ? 'primary' : 'default'
        };
        return (React.createElement(Toolbar_1.default, { flush: true, className: "r-Checkbox__Wrapper" },
            React.createElement(Button_1.default, __assign({ className: checkboxClass }, checkboxProps)),
            props.title ? (React.createElement(Button_1.default, __assign({}, checkboxProps, { simple: true }), props.title)) : null));
    };
    Checkbox.defaultProps = {
        checked: false
    };
    return Checkbox;
}(React.Component));
exports.default = Checkbox;
//# sourceMappingURL=Checkbox.js.map