"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Dropdown_1 = require("../Dropdown/Dropdown");
var Calendar_1 = require("./Calendar");
exports.Calendar = Calendar_1.default;
var DatePicker = (function (_super) {
    __extends(DatePicker, _super);
    function DatePicker(props) {
        var _this = _super.call(this, props) || this;
        _this.onSelect = function (date) {
            _this.setState({
                date: date
            });
            _this.props.onSelect ? _this.props.onSelect(date) : null;
        };
        var date = _this.props.date || new Date(Date.now());
        _this.state = {
            date: date,
            open: props.open || false
        };
        return _this;
    }
    DatePicker.prototype.componentDidUpdate = function (prevProps) {
        var self = this;
        if (prevProps.open !== this.props.open) {
            self.setState({
                open: this.props.open
            });
        }
        if (prevProps.date !== this.props.date) {
            self.setState({
                date: this.props.date
            });
        }
    };
    DatePicker.prototype.toggleOpen = function () {
        if (this.props.onClick) {
            this.props.onClick();
        }
        else {
            this.setState(function (state) {
                return {
                    open: !state.open
                };
            });
        }
    };
    DatePicker.prototype.toggleClose = function () {
        this.setState({
            open: false
        });
    };
    DatePicker.prototype.onOpen = function () {
        return null;
    };
    DatePicker.prototype.render = function () {
        var date = this.state.date;
        var _a = this.props, mobile = _a.mobile, title = _a.title, className = _a.className, outline = _a.outline, size = _a.size, block = _a.block;
        return (React.createElement(Dropdown_1.default, { className: className, icon: "calendar", material: true, title: title ? title : getDateFormatted(this.state.date, this.props.selectTime), mobile: mobile, open: this.state.open, onClick: this.toggleOpen.bind(this), onClose: this.toggleClose.bind(this), onCloseDropdown: this.toggleClose.bind(this), theme: this.props.theme, outline: outline, size: size, block: block, onOpen: this.onOpen.bind(this) },
            React.createElement(Calendar_1.default, { mobile: mobile, selectTime: this.props.selectTime, selectedDay: this.state.date, inDropdown: true, date: date, onSelect: this.onSelect })));
    };
    return DatePicker;
}(React.Component));
exports.default = DatePicker;
function getDateFormatted(date, selectTime) {
    var dd = date.getDate(), mm = date.getMonth() + 1, yyyy = date.getFullYear(), hours = date.getHours(), minutes = date.getMinutes(), day = dd < 10 ? '0' + dd : '' + dd, month = mm < 10 ? '0' + mm : '' + mm;
    if (selectTime) {
        return month + '/' + day + '/' + yyyy + ' - ' + hours + ':' + minutes;
    }
    else {
        return month + '/' + day + '/' + yyyy;
    }
}
//# sourceMappingURL=DatePicker.js.map