"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classNames = require("classnames");
require("intersection-observer");
var react_intersection_observer_1 = require("react-intersection-observer");
var Emerge = (function (_super) {
    __extends(Emerge, _super);
    function Emerge() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Emerge.prototype.render = function () {
        var self = this;
        var props = self.props;
        var index = 0;
        var emergeClass = classNames('r-Emerge', props.className, { 'e-enter': props.if }, { floshow: props.overflow });
        var newChildren = React.Children.map(this.props.children, function (child) {
            var exit, enter;
            if (props.if === true) {
                enter = props.enter;
            }
            else {
                enter = null;
            }
            if (props.if === false) {
                exit = props.exit;
            }
            else {
                exit = null;
            }
            var newClass = classNames('r-Emerge', 'animated', enter, exit, child.props.className);
            var newStyle = {
                animationDelay: index++ * props.delay + 'ms'
            };
            function merge_options(obj1, obj2) {
                var obj3 = {};
                for (var attrname in obj1) {
                    obj3[attrname] = obj1[attrname];
                }
                for (var attrname in obj2) {
                    obj3[attrname] = obj2[attrname];
                }
                return obj3;
            }
            return React.cloneElement(child, { className: newClass, style: merge_options(newStyle, props.style) });
        });
        return (React.createElement(react_intersection_observer_1.default, { triggerOnce: props.triggerOnce }, function (inView) {
            return inView ? (React.createElement("span", { className: emergeClass, ref: "element" }, newChildren)) : null;
        }));
    };
    Emerge.defaultProps = {
        if: true,
        enter: 'fadeInUp',
        exit: 'fadeOutDown',
        delay: 300,
        overflow: false
    };
    return Emerge;
}(React.Component));
exports.default = Emerge;
//# sourceMappingURL=Emerge.js.map