"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classNames = require("classnames");
var OOCSS_1 = require("../OOCSS/OOCSS");
var AdvancedLayer = (function (_super) {
    __extends(AdvancedLayer, _super);
    function AdvancedLayer(props) {
        var _this = _super.call(this, props) || this;
        _this.handleScroll = function (to, top) {
            var self = _this;
            self._beforeAnimate();
            self.setState({
                scrollToId: to
            }, function () {
                self.animateScroll(_this._animate, top);
            });
            self._afterAnimate();
        };
        _this.scrollToBottom = function () {
            var endPOffsetTop = _this.messagesEnd ? _this.messagesEnd : 0;
            _this.messagesEnd ? _this.handleScroll('end', endPOffsetTop.offsetTop) : null;
        };
        _this._scrollToId =
            (props.scrollToId && props.scrollToId !== '' && props.scrollToId.toString().replace(/^#/, '')) || '';
        var offset = props.offset || 0, duration = 400, easing = _this.easeOutQuad;
        _this._animate = { offset: offset, duration: duration, easing: easing };
        _this._beforeAnimate = props.beforeAnimate || function () { };
        _this._afterAnimate = props.afterAnimate || function () { };
        _this.state = {
            scrollToId: '',
            lastScrollY: 0,
            ticking: false
        };
        return _this;
    }
    AdvancedLayer.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.scrollIf && prevProps.scrollToId !== this.props.scrollToId) {
            this.canLayerAnimateScroll(this.props);
        }
        if (prevProps.length !== this.props.length && this.props.scrollToBottom) {
            this.scrollToBottom();
        }
    };
    AdvancedLayer.prototype.componentDidMount = function () {
        if (this.props.scrollIf && this.props.scrollToId !== '') {
            this.canLayerAnimateScroll(this.props);
        }
        this.props.scrollToBottom ? this.scrollToBottom() : null;
    };
    AdvancedLayer.prototype.canLayerAnimateScroll = function (props) {
        var propss = props || this.props;
        var self = this;
        setTimeout(function () {
            var element = document.getElementById(propss.scrollToId);
            if (element && element.getBoundingClientRect()) {
                self.handleScroll(propss.scrollToId, element.offsetTop);
            }
            else
                return null;
        }, 0);
    };
    AdvancedLayer.prototype.animateScroll = function (animate, top) {
        this.refs.Layer ? this.scrollTo(animate.duration, top) : null;
    };
    AdvancedLayer.prototype.scrollTo = function (duration, top) {
        this.animateScrolling(duration, top);
    };
    AdvancedLayer.prototype.animateScrolling = function (duration, top) {
        var self = this;
        var startY = this.getScrollTop();
        scrollTo(startY, this.refs.Layer, top, duration);
        self.setState({
            scrollToId: ''
        });
    };
    AdvancedLayer.prototype.setScrolling = function (x, y) {
        this.refs.Layer.scrollTop = y;
        this.refs.Layer.scrollLeft = x;
    };
    AdvancedLayer.prototype.easeOutQuad = function (t, b, c, d) {
        return -c * (t /= d) * (t - 2) + b;
    };
    AdvancedLayer.prototype.getScrollTop = function () {
        return this.refs.Layer.scrollTop || this.refs.Layer.scrollTop;
    };
    AdvancedLayer.prototype.setScrollTop = function (position) {
        this.refs.Layer.scrollTop = position;
    };
    AdvancedLayer.prototype.getOffsetTop = function (element) {
        var top = element.getBoundingClientRect().top;
        return top + this.getScrollTop();
    };
    AdvancedLayer.prototype.getScrollLeft = function () {
        return this.refs.Layer.scrollLeft || this.refs.Layer.scrollLeft;
    };
    AdvancedLayer.prototype.setScrollLeft = function (position) {
        this.refs.Layer.scrollLeft = position;
    };
    AdvancedLayer.prototype.getOffsetLeft = function (element) {
        var left = element.getBoundingClientRect().left;
        return left + this.getScrollLeft();
    };
    AdvancedLayer.prototype.render = function () {
        var _this = this;
        var self = this;
        var props = self.props;
        var dimensionStyle;
        if (props.dimensions) {
            dimensionStyle = {
                width: props.dimensions[0],
                height: props.dimensions[1],
                zIndex: props.dimensions[2]
            };
        }
        var layerClass = classNames('r-Layer', { flohide: props.overflow }, { 'pull-left': props.left }, { 'pull-right': props.right }, { 'e-NightMode': props.nightmode }, { 'e-scroll': props.scroll }, { 'e-scroll-y': props.scrollY }, { 'e-scroll-x': props.scrollX }, { 'e-borderRadius': props.borderRadius }, { 'e-dropShadow': props.dropShadow }, { disabled: props.disabled }, { 'e-flex': !!props.flex }, { 'e-flex-row': props.flex === 'row' }, { 'e-fill': props.fill }, { parent: props.parent }, { child: props.child }, { 'e-shadow': props.shadow }, { 'e-flex-center': props.flexCenter }, { 'border-all': props.border }, props.theme, props.className);
        return (React.createElement("div", { id: props.id, onScroll: this.props.onScroll, tabIndex: props.tabIndex, ref: "Layer", onClick: props.onClick, className: layerClass, style: Object.assign({}, dimensionStyle, props.style) },
            props.children,
            React.createElement("div", { id: "end", style: { float: 'left', clear: 'both' }, ref: function (el) {
                    _this.messagesEnd = el;
                } })));
    };
    AdvancedLayer.defaultProps = {
        overflow: false,
        type: '',
        left: false,
        right: false,
        border: '',
        scrollIf: false,
        flexCenter: false
    };
    return AdvancedLayer;
}(React.Component));
Math['easeInOutQuad'] = function (t, b, c, d) {
    t /= d / 2;
    if (t < 1) {
        return (c / 2) * t * t + b;
    }
    t--;
    return (-c / 2) * (t * (t - 2) - 1) + b;
};
Math['easeInCubic'] = function (t, b, c, d) {
    t /= d;
    return c * t * t * t + b;
};
Math['inOutQuintic'] = function (t, b, c, d) {
    var ts = (t /= d) * t, tc = ts * t;
    return b + c * (6 * tc * ts + -15 * ts * ts + 10 * tc);
};
var requestAnimFrame = (function () {
    return (window['requestAnimationFrame'] ||
        window['webkitRequestAnimationFrame'] ||
        window['mozRequestAnimationFrame'] ||
        function (callback) {
            window.setTimeout(callback, 2000 / 60);
        });
})();
function scrollTo(scrollTop, element, to, duration) {
    function move(amount) {
        element.scrollTop = amount;
    }
    function position() {
        return scrollTop;
    }
    var start = position(), change = to - start, currentTime = 0, increment = 10;
    duration = typeof duration === 'undefined' ? 500 : duration;
    var animateScroll = function () {
        currentTime += increment;
        var val = Math['inOutQuintic'](currentTime, start, change, duration);
        move(val);
        if (currentTime < duration) {
            requestAnimFrame(animateScroll);
        }
    };
    animateScroll();
}
exports.default = OOCSS_1.OOCSS()(AdvancedLayer);
//# sourceMappingURL=AdvancedLayer.js.map