"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classNames = require("classnames");
var Layer = (function (_super) {
    __extends(Layer, _super);
    function Layer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Layer.prototype.render = function () {
        var self = this;
        var props = self.props;
        var dimensionStyle;
        if (props.dimensions) {
            dimensionStyle = {
                width: props.dimensions[0],
                height: props.dimensions[1],
                zIndex: props.dimensions[2]
            };
        }
        var layerClass = classNames('r-Layer', { flohide: props.overflow }, { 'pull-left': props.left }, { 'pull-right': props.right }, { 'e-NightMode': props.nightmode }, { 'e-scroll': props.scroll }, { 'e-scroll-y': props.scrollY }, { 'e-scroll-x': props.scrollX }, { 'e-borderRadius': props.borderRadius }, { 'e-dropShadow': props.dropShadow }, { disabled: props.disabled }, { 'e-flex': !!props.flex }, { 'e-flex-row': props.flex === 'row' }, { 'e-fill': props.fill }, { parent: props.parent }, { child: props.child }, { 'e-shadow': props.shadow }, { 'e-flex-center': props.flexCenter }, { 'border-all': props.border }, props.theme, props.className);
        return (React.createElement("div", { id: props.id, onScroll: this.props.onScroll, tabIndex: props.tabIndex, ref: "Layer", onClick: props.onClick, className: layerClass, style: Object.assign({}, dimensionStyle, props.style) }, props.children));
    };
    Layer.defaultProps = {
        overflow: false,
        type: '',
        left: false,
        right: false,
        border: '',
        flexCenter: false
    };
    return Layer;
}(React.Component));
exports.default = Layer;
//# sourceMappingURL=Layer.js.map