"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classNames = require("classnames");
var Portal_1 = require("../Portal/Portal");
var ModalHeader_1 = require("./ModalHeader");
function guidGenerator() {
    var S4 = function () {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    };
    return S4() + S4() + '-' + S4() + '-' + S4() + '-' + S4() + '-' + S4() + S4() + S4();
}
var Modal = (function (_super) {
    __extends(Modal, _super);
    function Modal(props) {
        var _this = _super.call(this, props) || this;
        _this.toggleFullScreen = function () {
            _this.setState({
                fullScreen: !_this.state.fullScreen
            });
        };
        _this.closeModal = function () {
            _this.setState({
                open: false,
                showChildren: false
            });
            _this.props.onClose ? _this.props.onClose() : null;
        };
        _this.state = {
            fullScreen: props.fullScreen || false,
            open: props.open || false,
            showChildren: false
        };
        return _this;
    }
    Modal.prototype.componentDidMount = function () {
        this.props.open ? this.open() : this.close();
    };
    Modal.prototype.componentDidUpdate = function (prevProps, prevState) {
        this.props.open === true && prevState.open !== true
            ? this.open()
            : this.props.open === false && prevState.open !== false
                ? this.close()
                : null;
    };
    Modal.prototype.open = function () {
        this.beforeOpen();
        this.afterOpen();
    };
    Modal.prototype.beforeOpen = function () {
        this.props.beforeOpen ? this.props.beforeOpen() : null;
        this.openModal();
    };
    Modal.prototype.openModal = function () {
        var _this = this;
        this.setState({
            open: true
        }, function () {
            _this.afterOpen();
        });
    };
    Modal.prototype.afterOpen = function () {
        this.setState({
            showChildren: true
        });
    };
    Modal.prototype.close = function () {
        this.setState({
            open: false,
            showChildren: false
        });
    };
    Modal.prototype.render = function () {
        var self = this;
        var props = self.props;
        var modalWrapperClass = classNames('r-Modal', { 'e-show': this.state.open }, { ghost: props.ghost }, { 'e-float': props.float }, { 'e-fade': props.effect === 'fade' }, { 'e-fill': props.fill }, { 'e-fullscreen': self.state.fullScreen }, { mobile: props.mobile }, { 'e-flex-center': props.flexCenter }, { flohide: props.overflow });
        var modalClass = classNames('r-ModalContent', props.className);
        return (React.createElement(Portal_1.default, { portalType: "SlideIn", open: this.state.open, portalId: guidGenerator() }, this.state.showChildren ? (React.createElement("div", { className: modalWrapperClass },
            React.createElement("div", { ref: "Modal", className: modalClass, style: props.style },
                !props.hideHeader ? (React.createElement(ModalHeader_1.default, { open: this.state.open, icon: this.props.icon, title: this.props.title, fullScreen: this.state.fullScreen, toggleFullScreen: this.toggleFullScreen, onClose: this.closeModal, hideFullScreenButton: props.hideFullScreenButton, hideCloseButton: props.hideCloseButton, closeId: props.closeId })) : null,
                props.children))) : null));
    };
    return Modal;
}(React.Component));
exports.default = Modal;
//# sourceMappingURL=Modal.js.map