"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Toolbar_1 = require("../Toolbar/Toolbar");
var Notification = (function (_super) {
    __extends(Notification, _super);
    function Notification(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            time: 0,
            isOn: false,
            start: 0,
            view: 'visible'
        };
        _this.startTimer = _this.startTimer.bind(_this);
        _this.stopTimer = _this.stopTimer.bind(_this);
        _this.resetTimer = _this.resetTimer.bind(_this);
        return _this;
    }
    Notification.prototype.startTimer = function () {
        var _this = this;
        this.setState({
            isOn: true,
            time: this.state.time,
            start: Date.now() - this.state.time
        });
        this.timer = setInterval(function () {
            return _this.setState({
                time: Date.now() - _this.state.start
            });
        }, 1);
    };
    Notification.prototype.stopTimer = function () {
        this.setState({ isOn: false });
        clearInterval(this.timer);
    };
    Notification.prototype.resetTimer = function () {
        this.setState({ time: 0, isOn: false });
    };
    Notification.prototype.componentDidMount = function () {
        this.startTimer();
    };
    Notification.prototype.stopAndResetTimer = function () {
        this.stopTimer();
        this.resetTimer();
    };
    Notification.prototype.render = function () {
        var self = this;
        var props = self.props;
        var _a = this.state, time = _a.time, view = _a.view;
        var animationClass;
        if (time < 3000) {
            animationClass = 'fadeInUp';
        }
        else if (time < 4000 && time > 3000) {
            animationClass = 'fadeOut';
        }
        else {
            animationClass = 'hide';
        }
        return (view === 'visible' && animationClass !== 'hide') || (view === 'hiding' && animationClass !== 'hide') ? (React.createElement(Toolbar_1.default, { onMouseEnter: this.stopAndResetTimer.bind(this), onMouseLeave: this.startTimer.bind(this), block: true, textCenter: true, className: 'p10 m0 w100 e-light e-dropShadow animated' + ' ' + animationClass }, props.item.template)) : null;
    };
    return Notification;
}(React.Component));
exports.default = Notification;
//# sourceMappingURL=Notification.js.map