"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var Layer_1 = require("../Layer/Layer");
var SlideIn_1 = require("../SlideIn/SlideIn");
var PortalContent = (function (_super) {
    __extends(PortalContent, _super);
    function PortalContent(props) {
        var _this = _super.call(this, props) || this;
        _this.portalElement = null;
        _this.initPortal();
        return _this;
    }
    PortalContent.prototype.componentDidUpdate = function (prevProps, prevState) {
        this.initPortal();
    };
    PortalContent.prototype.initPortal = function () {
        var portalDOM;
        if (this.props.initialized) {
            portalDOM = document.getElementById('Recoil');
            this.portalElement = portalDOM;
        }
    };
    PortalContent.prototype.render = function () {
        if (this.portalElement) {
            return ReactDOM.createPortal(this.props.portalTemplate ? (this.props.portalTemplate) : (React.createElement(SlideIn_1.default, { id: this.props.portalId, flex: true, fill: true, onClose: this.props.onClose, title: this.props.title, icon: this.props.icon, className: "r-Portal z5", fixed: true, from: "bottom", if: this.props.open },
                React.createElement(Layer_1.default, { flex: true, fill: true }, this.props.children))), this.portalElement);
        }
        else
            return null;
    };
    PortalContent.defaultProps = {
        portalType: 'SlideIn'
    };
    return PortalContent;
}(React.Component));
exports.default = PortalContent;
//# sourceMappingURL=PortalContent.js.map