"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classNames = require("classnames");
var ShortCutProvider_1 = require("../ShortCut/ShortCutProvider");
var PortalProvider_1 = require("../Portal/PortalProvider");
var index_1 = require("./index");
function delegate(el, evt, sel, handler) {
    el.addEventListener(evt, function (event) {
        var t = event.target;
        while (t && t !== this) {
            if (t.matches(sel)) {
                handler.call(t, event);
            }
            t = t.parentNode;
        }
    });
}
var Recoil = (function (_super) {
    __extends(Recoil, _super);
    function Recoil(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            inputIsFocused: false,
            isMobile: props.isMobile || index_1.isMobile,
            isDesktop: false,
            isTablet: props.isTablet || index_1.isTablet,
            initialized: false
        };
        _this.detectMobile();
        return _this;
    }
    Recoil.prototype.componentDidMount = function () {
        this.isMobile(index_1.isMobile);
        this.setState({
            initialized: true
        });
    };
    Recoil.prototype.detectMobile = function () {
        var device;
        if (index_1.isMobile && !index_1.isTablet) {
            device = 'mobile';
        }
        else if (index_1.isTablet) {
            device = 'tablet';
        }
        else {
            device = 'desktop';
        }
        if (this.props.onDevice) {
            this.props.onDevice(device);
        }
    };
    Recoil.prototype.componentDidUpdate = function (prevProps, prevState) {
        !!this.props.isMobile && this.props.isMobile !== prevState.isMobile ? this.isMobile(this.props.isMobile) : null;
    };
    Recoil.prototype.isMobile = function (mobile) {
        var self = this;
        if (mobile) {
            delegate(self.refs.Recoil, 'focusin', 'input', function () {
                self.setState({
                    inputIsFocused: true
                });
            });
            delegate(self.refs.Recoil, 'focusout', 'input', function () {
                self.setState({
                    inputIsFocused: false
                });
            });
        }
    };
    Recoil.prototype.render = function () {
        var self = this;
        var props = self.props;
        var RecoilClass = classNames('r-Recoil', { 'e-NightMode': props.nightmode }, { flohide: props.overflow }, { 'e-scroll': props.scroll }, { 'e-scroll-y': props.scrollY }, { 'e-scroll-x': props.scrollX }, { 'e-inputIsFocused': this.state.inputIsFocused }, props.className);
        return (React.createElement(PortalProvider_1.default, { initialized: this.state.initialized },
            React.createElement(ShortCutProvider_1.default, { shortCutInitKey: props.shortCutInitKey },
                React.createElement("div", { ref: 'Recoil', id: 'Recoil', className: RecoilClass }, this.props.children))));
    };
    return Recoil;
}(React.Component));
exports.default = Recoil;
//# sourceMappingURL=Recoil.js.map