"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var get_ua_data_1 = require("./get-ua-data");
var isMobileType = function () { return (get_ua_data_1.device.type === "mobile" ? true : false); };
var isTabletType = function () { return (get_ua_data_1.device.type === "tablet" ? true : false); };
var isMobileAndTabletType = function () {
    switch (get_ua_data_1.device.type) {
        case "mobile":
            return true;
        case "tablet":
            return true;
        default:
            return false;
    }
};
var isBrowserType = function () { return (get_ua_data_1.device.type === undefined ? true : false); };
var isAndroidType = function () { return (get_ua_data_1.os.name === "Android" ? true : false); };
var isWinPhoneType = function () { return (get_ua_data_1.os.name === "Windows Phone" ? true : false); };
var isIOSType = function () { return (get_ua_data_1.os.name === "iOS" ? true : false); };
var isChromeType = function () { return (get_ua_data_1.browser.name === "Chrome" ? true : false); };
var isFirefoxType = function () { return (get_ua_data_1.browser.name === "Firefox" ? true : false); };
var isChromiumType = function () { return (get_ua_data_1.browser.name === 'Chromim' ? true : false); };
var isSafariType = function () { return get_ua_data_1.browser.name === "Safari" || get_ua_data_1.browser.name === "Mobile Safari" ? true : false; };
var isMobileSafariType = function () { return get_ua_data_1.browser.name === "Mobile Safari" ? true : false; };
var isOperaType = function () { return (get_ua_data_1.browser.name === "Opera" ? true : false); };
var isIEType = function () { return (get_ua_data_1.browser.name === "Internet Explorer" ? true : false); };
var getBrowserFullVersion = function () { return get_ua_data_1.browser.major; };
var getBrowserVersion = function () { return get_ua_data_1.browser.version; };
var getOsVersion = function () { return (get_ua_data_1.os.version ? get_ua_data_1.os.version : "none"); };
var getOsName = function () { return (get_ua_data_1.os.name ? get_ua_data_1.os.name : "none"); };
var getBrowserName = function () { return get_ua_data_1.browser.name; };
var getMobileVendor = function () { return (get_ua_data_1.device.vendor ? get_ua_data_1.device.vendor : "none"); };
var getMobileModel = function () { return (get_ua_data_1.device.model ? get_ua_data_1.device.model : "none"); };
var getEngineName = function () { return get_ua_data_1.engine.name; };
var getEngineVersion = function () { return get_ua_data_1.engine.version; };
var getUseragent = function () { return get_ua_data_1.ua; };
exports.isMobileSafari = isMobileSafariType();
exports.isChromium = isChromiumType();
exports.isMobile = isMobileAndTabletType();
exports.isMobileOnly = isMobileType();
exports.isTablet = isTabletType();
exports.isBrowser = isBrowserType();
exports.isAndroid = isAndroidType();
exports.isWinPhone = isWinPhoneType();
exports.isIOS = isIOSType();
exports.isChrome = isChromeType();
exports.isFirefox = isFirefoxType();
exports.isSafari = isSafariType();
exports.isOpera = isOperaType();
exports.isIE = isIEType();
exports.osVersion = getOsVersion();
exports.osName = getOsName();
exports.fullBrowserVersion = getBrowserFullVersion();
exports.browserVersion = getBrowserVersion();
exports.browserName = getBrowserName();
exports.mobileVendor = getMobileVendor();
exports.mobileModel = getMobileModel();
exports.engineName = getEngineName();
exports.engineVersion = getEngineVersion();
exports.getUA = getUseragent();
//# sourceMappingURL=selectors.js.map