"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var initialData = {
    isMobile: false,
    isTablet: false,
    isBrowser: false
};
exports.checkType = function (type) {
    switch (type) {
        case "mobile":
            return {
                isMobile: true
            };
        case "tablet":
            return {
                isTablet: true
            };
        case undefined:
            return {
                isBrowser: true
            };
        default:
            return initialData;
    }
};
exports.getCurrentBrowser = function (name) {
    switch (name) {
        case "Chrome":
            return true;
        case "Firefox":
            return true;
        case "Opera":
            return true;
        case "Yandex":
            return true;
        case "Safari":
            return true;
        case "IE":
            return true;
        case "Edge":
            return true;
        case "Chromium":
            return true;
        default:
            return false;
    }
};
exports.broPayload = function (isBrowser, browser, engine, os, ua) {
    return {
        isBrowser: isBrowser,
        browserMajorVersion: browser.major,
        browserFullVersion: browser.version,
        browserName: browser.name,
        engineName: engine.name || false,
        engineVersion: engine.version,
        osName: os.name,
        osVersion: os.version,
        userAgent: ua
    };
};
exports.mobilePayload = function (type, device, os, ua) {
    return {
        type: type,
        vendor: device.vendor || "none",
        model: device.model || "none",
        os: os.name || "none",
        osVersion: os.version || "none",
        ua: ua || "none"
    };
};
//# sourceMappingURL=types.js.map