"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
exports.ShortcutContext = React.createContext('');
var ShortCutProvider = (function (_super) {
    __extends(ShortCutProvider, _super);
    function ShortCutProvider(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            showShortcut: false
        };
        return _this;
    }
    ShortCutProvider.prototype.componentDidMount = function () {
        var self = this;
        var props = self.props;
        if (props.shortcut) {
            window.addEventListener('keydown', this.startShortcutListener.bind(this), false);
            window.addEventListener('keyup', this.startShortcutListener.bind(this), false);
        }
    };
    ShortCutProvider.prototype.startShortcutListener = function (e) {
        var context = this;
        var props = context.props;
        var refButton = ReactDOM.findDOMNode(context.refs['button']);
        context.setState({
            showShortcut: e.shiftKey ? true : false
        });
        if (e.shiftKey && e.code === 'Key' + props.shortcut.toUpperCase()) {
            refButton.focus();
        }
    };
    ShortCutProvider.prototype.componentWillUnmount = function () {
        if (this.props.shortcut) {
            window.removeEventListener('keydown', null, false);
            window.removeEventListener('keyup', null, false);
        }
    };
    ShortCutProvider.prototype.render = function () {
        return (React.createElement(exports.ShortcutContext.Provider, { value: this.props.shortCutInitKey }, this.props.children));
    };
    return ShortCutProvider;
}(React.Component));
exports.default = ShortCutProvider;
//# sourceMappingURL=ShortCutProvider.js.map