"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classNames = require("classnames");
var Pager_1 = require("../Pager/Pager");
var WizardSlide = function (props) {
    return React.createElement("div", { className: props.className }, props.visible ? props.children : null);
};
var Wizard = (function (_super) {
    __extends(Wizard, _super);
    function Wizard() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onSlide = function (slideIndex) {
            _this.props.onSlide ? _this.props.onSlide(slideIndex) : null;
        };
        return _this;
    }
    Wizard.prototype.render = function () {
        var self = this;
        var props = self.props;
        var wizardClass = classNames('r-Wizard', { 'e-fill': props.fill }, { 'e-flex': props.flex || props.paginate }, { 'e-overflow': props.overflow });
        var createSlidesPartial = function (item, index) {
            var selected = props.slideIndex === index;
            var wizardSlideClass = classNames('r-WizardSlide', { 'e-selected': props.slideIndex === index }, { 'e-backward': props.slideIndex > index }, { 'e-forward': props.slideIndex < index }, { 'e-vertical': props.vertical }, { 'e-dont-animate': props.animate === false }, {
                'e-selected-relative': props.selectedIsRelative === true && props.slideIndex === index
            }, props.className);
            return (React.createElement(WizardSlide, { visible: selected, className: wizardSlideClass, key: index }, item));
        };
        if (props.children.length > 1) {
            return (React.createElement("div", { ref: "r-Wizard", className: wizardClass, style: props.style },
                React.createElement("div", { ref: "r-Wizard__track", className: "r-Wizard__track" }, props.children.map(createSlidesPartial)),
                props.paginate ? (React.createElement(Pager_1.default, { numberOfPages: props.children.length, currentPage: props.slideIndex, gotoPage: this.onSlide, hidePageSize: true })) : null));
        }
        else {
            return props.children;
        }
    };
    Wizard.defaultProps = {
        slideIndex: 0
    };
    return Wizard;
}(React.Component));
exports.default = Wizard;
//# sourceMappingURL=Wizard.js.map